import requests
from requests_toolbelt.multipart.encoder import MultipartEncoder
import csv
import sys
import json
import os

import config

headers_json={
    'Content-Type':'application/json',
    'Authorization': 'Token {}'.format(config.POD_TOKEN)
}
inputCsvFile=sys.argv[1]

try:
    with open(inputCsvFile, newline='') as csvfile:
        reader = csv.reader(csvfile, delimiter=',', quotechar='|')
        for row in reader:
            if(row[0].startswith("#") != True):
                # print(row)
                username=row[0]
                user_first_name=row[1]
                user_last_name=row[2]
                user_email=row[3]
                # print("%s %s %s %s" % (username, user_first_name, user_last_name, user_email))
                
                # TEST IF USER EXIST
                payload_search_user={
                    "username": username
                }
                
                response = requests.get(config.POD_API_USERS, headers=headers_json, params=payload_search_user)
                if(response.status_code != 200):
                    print("ERROR Test User exists [%s] : [CODE:%s] [MSG:%s]" % (username,response.status_code, json.loads(response.content.decode("utf-8"))))
                else:
                    result = json.loads(response.content.decode("utf-8"))
                    if(result['count'] != 1):
                        # print("User don't exists [%s]" % (username))
                        
                        # CREATE USER
                        payload_create_user={
                            "username": username,
                            "first_name": user_first_name,
                            "is_staff": "true",
                            "last_name": user_last_name,
                            "email": user_email,
                            "groups": []
                        }
                        
                        response = requests.post(config.POD_API_USERS, headers=headers_json, data=json.dumps(payload_create_user))
                        if(response.status_code != 201):
                            print("ERROR Create User [%s] : [CODE:%s] [MSG:%s]" % (username,response.status_code, json.loads(response.content.decode("utf-8"))))
                        else:
                            result = json.loads(response.content.decode("utf-8"))
                            username=result['username']
                            user_url=result['url']
                            print("New user created [%s] [%s]" % (username, user_url))
                    else:
                        user_url=result['results'][0]['url']        
                        print("User already exists [%s] [%s]" % (username, user_url))

except FileNotFoundError as e:
    print('File [%s] not found' % inputCsvFile)   